﻿using System.ComponentModel.DataAnnotations;

namespace Assignment3.Models
{
    public class Immunization
    {
        [Key]
        public Guid Id { get; private set; } = Guid.NewGuid();

        [Required]
        public DateTimeOffset CreationTime { get; private set; } = DateTimeOffset.UtcNow;

        [Required]
        [MaxLength(128)]
        public string OfficialName { get; set; } = string.Empty;

        [MaxLength(128)]
        public string? TradeName { get; set; }

        [Required]
        [MaxLength(255)]
        public string LotNumber { get; set; } = string.Empty;

        [Required]
        public DateTimeOffset ExpirationDate { get; set; }

        public DateTimeOffset? UpdatedTime { get; private set; }

    }
}
